{**********************************************************************
                 PilotLogic Software House
                
 Package pl_VirtualTrees
 This file is part of CodeTyphon Studio (https://www.pilotlogic.com/)
***********************************************************************}

unit AllVirtualTreeviewRegister;

{$Mode ObjFpc}
{$H+}

interface

uses 
  Classes, SysUtils, LResources, TyphonPackageIntf,
  ComponentEditors, PropEdits,
  VirtualTrees;

type


  TVirtualTreeCast = class(TBaseVirtualTree);

  TVirtualTreeEditor = class(TComponentEditor)
  public
    procedure Edit; override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): string; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;
  
procedure Register;

implementation

{$R AllVirtualTreeviewRegister.res}
           
procedure TVirtualTreeEditor.Edit;
var
  Tree: TVirtualTreeCast;
begin
  Tree := TVirtualTreeCast(GetComponent);
  TCollectionPropertyEditor.ShowCollectionEditor(Tree.Header.Columns, Tree, 'Columns');
end;

function TVirtualTreeEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

function TVirtualTreeEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := 'Edit Columns...';
  end;
end;

procedure TVirtualTreeEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: Edit;
  end;
end;

procedure Register;
begin
  RegisterComponents('Virtual Controls', [
                                          TVirtualDrawTree,
                                          TVirtualStringTree,
                                          TVTHeaderPopupMenu
                                          ]);

  RegisterComponentEditor([TVirtualDrawTree, TVirtualStringTree], TVirtualTreeEditor);
end; 

end.
